   ;-----------------------------------------------------;
   ;  Nzev    : Digitln kuchysk vha                ;
   ;  Rozsah   : 0 a 2,5 kg                             ;
   ;  Pesnost : 10g                                     ;
   ;  Autor    : Pavel Jank                             ;
   ;  Vroba   : 2003-2004				 ;
   ;  Verze    : 2.1 (z 5.5.2004)			 ;
   ;-----------------------------------------------------;

STR	BIT P1.5		;strobovani (H = data z pos. reg. na LCD)
DAT	BIT P1.4                ;seriove data na pos. reg.
CLK	BIT P1.6                ;hodiny pos. reg.
COM	BIT P1.3		;spolecny vyvod displeje
SIR	BIT P1.7		;sirnka (spoust. log. 0)
OFF	BIT P3.7		;automatick vypnut za nastaven cas (log. 0)
P_CSN	BIT P1.0		;Chip Select prevodniku - negovan
P_CLK	BIT P1.1                ;hodiny prevodniku
P_DAT	BIT P1.2                ;pjem dat z pevodnku
;--------------
;R0 	- 			 pomocny reg.
;R1 	- 			 pomocny reg.
;R2 	- 			 odpocitavani automat. OFF (250)
;R3 	- 			 odpocitavani automat. OFF (6)
;R5 	- 			 kolikrat byl bit vyslan na pos. reg. (8)
;R6 	- 			 kolikrat byl bit precten z AD 	      (8)
;R7 	- 			 urcuje negovani dat na LCD
;--------------
CEK_CTI	EQU 17H			;zpomaluje cteni z DA
OUT_AD	EQU 18H			;binarni vystup z AD prevodniku
Z_AD	EQU 19H			;odectena hodnota pro zpracovani
NUL_AD	EQU 20H			;hodnota ulozena pri stisku NUL. tlac.
CETL_AD EQU 21H               	;urcuje (255) jestli cetl data z AD
NA_DISP EQU 22H               	;urcuje (255) jestli ma vysilat data na LCD
PaJa    EQU 23H			;doba (po zapnuti) sviceni PAJA na LCD
;--------------
TIS	EQU 24H			;TISice binrn hodnota z AD
STA	EQU 25H
DES	EQU 26H
JED	EQU 27H
D_TIS	EQU 28H			;TISice data hodnoty zabrazovane na displeji
D_STA	EQU 29H
D_DES	EQU 30H
D_JED	EQU 31H
;-------------------------------------------------------------------------------

	ORG 000H
	JMP NASTAV			;Po resetu skoc na nastaveni programu
	ORG 003H
	JMP NULOVANI 			;Preruseni pri nuluvani vahy 
	ORG 00BH
	JMP NA_LCD              	;Preruseni, ktere vysila hodnoty na LCD
	ORG 01BH
	JMP CTI_Z_AD            	;Preruseni, ktere cte hodnotu z AD
        ORG 100H

;-------------------------------------------------------------------------------
;Nastaveni hodnot (inicializace)
NASTAV: MOV P1,#10111101B		;vynuluj CLK a P_CLK
	MOV P3,#11111111B
        MOV R2,#255			;odpocet stopek pro OFF (2 minuty)
        MOV R3,#177	                ;odpocet stopek pro OFF 
	MOV OUT_AD,#0
	MOV NUL_AD,#0
       	MOV R7,#0			;urcuje negovani dat na LCD
	MOV IE,#10001011B 		;povoli preruseni od INT0, TF0 a TF1
	MOV TMOD,#00010001B		;nastaveni casovace 0 a 1 do modu 1 
	MOV TH1,#0			;pustit casovac 1 (cti z AD)
	MOV TH0,#111			;pustit casovac 0 - 50x/s (na LCD)
	MOV TCON,#01010001B		;spusti cas.0 a 1,INT0 aktiv na sestup.
	MOV D_TIS,#00000011B		;cislo 0, prednastaveni (vynulovani)
	MOV D_STA,#00000011B		;cislo 0
	MOV D_DES,#00000011B		;cislo 0
	MOV D_JED,#00000011B		;cislo 0
	MOV PaJa,#100                   ;doba (po zapnuti) sviceni PAJA na LCD
	MOV CEK_CTI,#3

;************************** START VLASTNIHO PROGRAMU **************************
	JMP CTI
HL_PROG:MOV A,OUT_AD
	SUBB A,NUL_AD			;odecte od namerene hodnoty nulovanou
	JC MINUSY                       ;pri zaporne hodnote zobraz ----
	MOV Z_AD,A			;odectena hodnota k dalsimu zpracovani
	MOV R1,OUT_AD
	CJNE R1,#0,VAZI_NE		;kdyz je na vaze zavazi, tak nevypinej
;kdyz je nulova hmotnost, tak stopovat (1500x) a pak vypni napajeni (OFF=log.0)
	CJNE R2,#0,POKR0		;kdyz uz R2=0,
        JMP POKR1                       ;tak skoc dal
POKR0:	DJNZ R2,VAZI			;dekrementuje (snizi) R2 (250 az 0)
	JMP VAZI                        ;kdyz ted R2=0, tak skoc na VAZenI
POKR1:  MOV R2,#255
	DJNZ R3,VAZI
VYPNOUT:CLR OFF				;kdyz R3=0, tak vypne napajeni vahy    
	
VAZI_NE:MOV R2,#255                     ;kdyz vazi, tak vynuluj odpocet pro 
	MOV R3,#177			;vypnuti vahy, cas 2 minut

VAZI:   MOV A,OUT_AD
	MOV B,#251  			
	DIV AB				;vystup z AD del 251, kdyz OUT_AD > 250
	JZ  NEXT        		;tak spust sirenu
	CALL SIRENA
MINUSY:	MOV D_JED,#11111101B		;na displeji zobrazi -
	MOV D_DES,#11111101B		;na displeji zobrazi -
	MOV D_STA,#11111101B		;na displeji zobrazi -
	MOV D_TIS,#11111101B		;na displeji zobrazi -
	JMP POR_DIS
NEXT:	CLR A 

;kolik TISice, STA, DESitky, JEDnotky jde na zobrazeni hmotnosti
	MOV A,Z_AD
	MOV B,#100
	DIV AB
	MOV TIS,A	
	MOV A,#10
	XCH A,B
	DIV AB
	MOV STA,A	
	MOV A,B
	MOV DES,B
	MOV JED,#0
;Prevod desitkovych cisel -> BINarni pro pos.reg. (zobrazeni na LCD) a 
;vypnuti zbytecne sviticich nul vlevo pred cislem (napr.: 0050 =>  __50)
	MOV DPTR,#TAB_CIS		;uloz pocatecni adresu tabulky
	
	MOV A,JED
	MOVC A,@A+DPTR	          	;najdi v TAB_CIS a prirad bin. hodnotu
	MOV D_JED,A

	MOV A,DES
	JNZ DAL_D1                      ;zjisti zda DES=0, jinak skoc DAL_D1
	MOV A,STA                       
        JNZ DAL_D1			;zjisti zda STA=0, jinak skoc DAL_D1
        MOV A,TIS
	JNZ DAL_D1                      ;zjisti zda TIS=0, jinak skoc DAL_D1
	MOV A,#10                       ;kdyz DES=STA=TIS=0 tak zobraz nic
	JMP DAL_N1
DAL_D1:	MOV A,DES
DAL_N1: MOVC A,@A+DPTR
	MOV D_DES,A

	MOV A,STA
	JNZ DAL_D2
	MOV A,TIS
	JNZ DAL_D2
	MOV A,#10
	JMP DAL_N2
DAL_D2:	MOV A,STA	
DAL_N2:	MOVC A,@A+DPTR
	MOV D_STA,A

	MOV A,TIS
	JNZ DAL_D3
	MOV A,#10
DAL_D3:	MOVC A,@A+DPTR
	MOV D_TIS,A

;---------------------------- vysilani na displej -----------------------------
POR_DIS:MOV A,NA_DISP 			;zjistuje, jestli nema vysilat na LCD
	CJNE A,#255,POR_CTL
;po zapnuti vahy zobraz na displeji PaJa	
	MOV A,PaJa
	CJNE A,#0,DA1
        JMP PS_KON
DA1:	DJNZ PaJa,DA2
	JMP PS_KON
DA2:	MOV D_TIS,#00110001B		;pismeno P
	MOV D_STA,#00010001B		;pismeno A
	MOV D_DES,#10000111B		;pismeno J
	MOV D_JED,#00010001B		;pismeno A
PS_KON: 				;konec zobrazeni PaJa
	CLR  STR
	CJNE R7,#255,DALE
	MOV A,D_TIS
	CPL A				;invertuj jednotky
	CALL VYSILEJ
	MOV A,D_STA
	CPL A				;invertuj desitky
	CALL VYSILEJ
	MOV A,D_DES
	CPL A				;invertuj stovky
	CALL VYSILEJ
	MOV A,D_JED
	CPL A				;invertuj tisice
	CALL VYSILEJ
	CLR COM				;spol. vyvod LCD do log. 0
	SETB STR                        ;nastav strobovani pos.reg.
	MOV R7,#0
	MOV NA_DISP,#0	
	JMP POR_CTL
DALE:	MOV A,D_TIS
	CALL VYSILEJ
	MOV A,D_STA
	CALL VYSILEJ
	MOV A,D_DES
	CALL VYSILEJ
	MOV A,D_JED
	CALL VYSILEJ
	SETB COM
	SETB STR
	MOV R7,#255
	MOV NA_DISP,#0

;------------------------------- cteni z AD ----------------------------------	
POR_CTL:MOV A,CETL_AD
	CJNE A,#255,POR_DIS		;zjistuje, jestli uz ma cist z AD
CTI:	CLR P_CSN                       ;nastav Chip Select do log. 0 (aktivni)
	NOP				;casova prodleva pred novym ctenim z AD
	NOP                             ;minimalne 1,6 us
	NOP
	NOP
	CLR A				;vynuluj stradac ACC
	MOV R6,#8			;cteni jednotlivych bitu opakovat 8x
CTI2:	SETB P_CLK			;nastav CLocK AD do log. 1
	MOV C, P_DAT      		;prenes 1 bit z AD do prenosu C
	RLC A				;posun bit z C v ACC o 1 pozici doleva
	CLR P_CLK                       ;nastav CLocK AD do log. 0
	DJNZ R6,CTI2			;opakuj dokud neni precteno 8bitu z AD
	SETB P_CSN			;nastav Chip Select do log. 1 (neaktiv)
	MOV OUT_AD,A			;nactena data do OUT_AD na zpracovani
	CLR C
	MOV CETL_AD,#0	
	MOV CEK_CTI,#3			;zpomaluje cteni z AD
		
	JMP HL_PROG			;vrat se na zacatek hl. programu
;------------------------------------------------------------------------------
VYSILEJ:MOV R5,#8      			;vysilani jednoho bitu 8x (8-bitu)
VYSLI:  RRC A                    	;posun vpravo v ACC o jeden bit do C
	CLR CLK                         ;vypni CLocK pos. reg.
	MOV DAT,C			;vysli C na vstup DAT pos. reg.
	SETB CLK			;pri CLK=1 se zapisi DATa do pos. reg.
	DJNZ R5,VYSLI			;sniz R5,kdyz R5<>0 tak opakuj vysilani
	CLR C
        RET
;------------------------------------------------------------------------------
;tabulka prirazeni kodu pro LCD cislu 0 az 9 , nic
TAB_CIS:DB 00000011B			;cislo 0
	DB 10011111B			;cislo 1
	DB 00100101B			;cislo 2
	DB 00001101B			;cislo 3
	DB 10011001B			;cislo 4
	DB 01001001B			;cislo 5
	DB 01000001B			;cislo 6
	DB 00011111B			;cislo 7
	DB 00000001B			;cislo 8
	DB 00001001B			;cislo 9
	DB 11111111B			;nic nezobrazi
;==============================================================================

;podprogram, ktery spusti sirenu v pripade prekroceni hmotnosti 2,5 Kg
SIRENA:	CLR SIR 			;spusti sirenku a signalizacni LED
	MOV R1,#255
opr:	MOV R0,#100
	DJNZ R0,$
	DJNZ R1,opr
	SETB SIR              		;vypne sirenku
	RET
;******************************* Preruseni ************************************
;Preruseni, ktere ulozi aktualni vazenou hmotnost (pro jeji dalsi odecitani)
NULOVANI:PUSH ACC		
	PUSH PSW
	MOV NUL_AD,OUT_AD		;uloz aktualni vazenou hodnotu
	MOV R6,#200             	;casova prodleva
	DJNZ R6,$	
	POP PSW
	POP ACC
	RETI
;------------------------------------------------------------------------------
;Preruseni, ktere nacte hodnoty z AD a ulozi je do OUT_AD
CTI_Z_AD:PUSH ACC
	PUSH PSW
	DJNZ CEK_CTI,CKJ_KON
	MOV CETL_AD,#255		;signalizace hl. programu, ze cetl z AD
CKJ_KON:MOV TH1,#0			;obnov hodnoty casovace
	POP PSW                         
	POP ACC
	RETI
;------------------------------------------------------------------------------
;Preruseni signalizujici hl. programu vysilani dat na LCD displej (50x/s)
NA_LCD:	PUSH ACC
	PUSH PSW
	MOV NA_DISP,#255		;signal hl.programu aby vysilal na LCD	
	MOV TH0,#111			;obnov hodnoty casovace - 50x/s
	POP PSW
	POP ACC
	RETI
		
	END
;********************************** KONEC *************************************
; Copyright (C) PaJa 2004				   www.paja-trb.unas.cz
